<?php

namespace Sprinix\RequestQuote\Block\Adminhtml;

use Magento\Framework\View\Element\Template;
use Magento\Backend\Block\Template\Context;
use Sprinix\RequestQuote\Model\ResourceModel\QuoteItem\CollectionFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;

/**
 * Class AdminView
 * @package Sprinix\RequestQuote\Block\Adminhtml
 */
class AdminView extends Template
{
    /**
     * @var CollectionFactory
     */
    public $collection;

    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * AdminView constructor.
     * @param Context $context
     * @param CollectionFactory $collectionFactory
     * @param array $data
     * @param QuoteFactory $quoteFactory
     */
    public function __construct(
        Context $context,
        CollectionFactory $collectionFactory,
        QuoteFactory $quoteFactory,
        array $data = []
    )
    {
        $this->collection = $collectionFactory;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context, $data);
    }

    /**
     * @return array
     */
    public function getDataCollection()
    {
        try {
            $quote_id = $this->getRequest()->getParam('quote_id');
            $status = $this->quoteFactory->create()->getCollection()->addFieldToSelect('customer_action_status')
                ->addFieldToFilter('quote_id', $quote_id)
                ->getFirstItem()->getData();
            if ($status['customer_action_status'] == 'submitted') {
                return $this->collection->create()
                    ->addFieldToFilter('quote_id', ['eq' => $quote_id])->getData();
            }
        } catch (\Exception $e) {
        }
    }

    /**
     * @return mixed
     */
    public function quoteDetail()
    {
        return $quote_id = $this->getRequest()->getParam('quote_id');
    }

    /**
     * @return mixed
     */
    public function buttonCheck()
    {
        try{
        $quote_id = $this->getRequest()->getParam('quote_id');
        $data = $this->quoteFactory->create()
            ->load($quote_id)->
            getData('customer_action_status');
        return $data;
        }catch (\Exception $e){
        }
    }

    /**
     * @return mixed
     */
    public function orderPlacedAfter()
    {
         try {

             $quote_id = $this->getRequest()->getParam('quote_id');
             $collection = $this->quoteFactory->create()
                 ->getCollection()
                 ->addFieldToFilter('quote_id', $quote_id)
                 ->getFirstItem()
                 ->getData();
             $status = $collection['status'];
             return $status;
         }catch (\Exception $e){
         }
    }


}