<?php

namespace Sprinix\RequestQuote\Block;

use Sprinix\RequestQuote\Model\ResourceModel\QuoteItem\CollectionFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Framework\View\Element\Template\Context;
use Magento\Customer\Model\Session;
use Magento\Framework\Registry;
use Magento\Framework\Stdlib\DateTime\TimezoneInterface;
use Magento\Catalog\Api\ProductRepositoryInterface;
use Magento\Framework\App\Http\Context as HttpContext;

/**
 * Class ProductAndSessionData
 * @package Request\RequestQuote\Block
 */
class Linkdetails extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Magento\Customer\Model\Session
     */
    public $customerSession;

    /**
     * @var CollectionFactory
     */
    public $collection;

    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * @var \Magento\Framework\Stdlib\DateTime\TimezoneInterface
     */
    protected $date;

    /**
     * @var \Magento\Framework\App\Http\Context
     */
    protected $httpContext;

    /**
     * Linkdetails constructor.
     * @param CollectionFactory $PostFactory
     * @param QuoteFactory $quoteFactory
     * @param Context $context
     * @param Session $customerSession
     * @param Registry $registry
     * @param TimezoneInterface $date
     * @param ProductRepositoryInterface $productRepository
     * @param HttpContext $httpContext
     * @param array $data
     */
    public function __construct(
        CollectionFactory $PostFactory,
        QuoteFactory $quoteFactory,
        Context $context,
        Session $customerSession,
        Registry $registry,
        TimezoneInterface $date,
        ProductRepositoryInterface $productRepository,
        HttpContext $httpContext,
        array $data = []
    )
    {
        $this->productRepository = $productRepository;
        $this->collection = $PostFactory;
        $this->date = $date;
        $this->httpContext = $httpContext;
        $this->customerSession = $customerSession;
        $this->quoteFactory = $quoteFactory;
        $this->_registry = $registry;
        parent::__construct($context, $data);
    }

    /**
     * @return int
     */
    public function getCustomerIsLoggedIn()
    {
        $log = $this->httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH);

        if (empty($log)) {
            return 0;
        } else {
            return 1;
        }
    }
}


