<?php

namespace Sprinix\RequestQuote\Block;

use Magento\Framework\View\Element\Template\Context;
use Magento\Customer\Model\Session;
use Magento\Framework\App\Http\Context as HttpContext;

/**
 * Class QuoteCounter
 * @package Request\RequestQuote\Block
 */
class QuoteCounter extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;


    /**
     * @var \Magento\Framework\App\Http\Context
     */
    protected $httpContext;

    /**
     * QuoteCounter constructor.
     * @param Context $context
     * @param Session $customerSession
     * @param HttpContext $httpContext
     * @param array $data
     */
    public function __construct(
        Context $context,
        Session $customerSession,
        HttpContext $httpContext,
        array $data = []
    )
    {
        parent::__construct($context, $data);
        $this->customerSession = $customerSession;
        $this->httpContext = $httpContext;
    }

    /**
     * @return int|null
     */
    public function getCustomerIsLoggedIn()
    {
        $log = $this->httpContext->getValue('customer_id');
        if (empty($log)) {
            return 0;
        } else {
            return 1;
        }
    }

}