<?php

namespace Sprinix\RequestQuote\Block;

use Magento\Framework\View\Element\Template\Context;
use Magento\Customer\Model\Session;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Framework\App\Http\Context as HttpContext;

/**
 * Class Submittedquotes
 * @package Sprinix\RequestQuote\Block
 */
class Submittedquotes extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * @var \Sprinix\RequestQuote\Model\QuoteFactory
     */
    protected $quoteFactory;

    /**
     * @var
     */
    protected $httpContext;

    /**
     * Submittedquotes constructor.
     * @param Context $context
     * @param Session $customerSession
     * @param QuoteFactory $quoteFactory
     * @param HttpContext $httpContext
     * @param array $data
     */
    public function __construct(
        Context $context,
        Session $customerSession,
        QuoteFactory $quoteFactory,
        HttpContext $httpContext,
        array $data = []
    )
    {
        parent::__construct($context, $data);
        $this->customerSession = $customerSession;
        $this->quoteFactory = $quoteFactory;
        $this->httpContext = $httpContext;
    }

    /**
     * @return int|null
     */
    public function customerId()
    {
        $customer_id = $this->httpContext->getValue('customer_id');
        return $customer_id;
    }

    /**
     * @return array
     */
    public function viewQuotes()
    {
        try{
            $customer_id = $this->httpContext->getValue('customer_id');
            $data = $this->quoteFactory->create()
                ->getCollection()
                ->addFieldToFilter('customer_id', $customer_id)
                ->addFieldToFilter('customer_action_status', 'submitted')
                ->getData();
            return $data;
        }catch (\Exception $e){
        }

    }
}