<?php

namespace Sprinix\RequestQuote\Controller\Adminhtml\Checkquotes;

use Magento\Backend\App\Action\Context;
use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Sprinix\RequestQuote\Helper\Email;
use Sprinix\RequestQuote\Model\QuoteFactory;


/**
 * Class Savequotes
 * @package Sprinix\RequestQuote\Controller\Adminhtml\Checkquotes
 */
class Savequotes extends \Magento\Backend\App\Action
{
    /**
     * @var
     */
    protected $customFactory;

    /**
     * @var
     */
    protected $adapterFactory;

    /**
     * @var
     */
    protected $uploader;

    /**
     * @var
     */
    protected $id;

    /**
     * @var Email
     */
    protected $etmail;
    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * @var QuoteItemFactory
     */
    protected $collectionFactory;

    /**
     * Savequotes constructor.
     * @param Context $context
     * @param QuoteItemFactory $quoteitemFactory
     * @param Email $etmail
     * @param QuoteFactory $quoteFactory
     */
    public function __construct(
        Context $context,
        QuoteItemFactory $quoteitemFactory,
        Email $etmail,
        QuoteFactory $quoteFactory

    )
    {
        parent::__construct($context);

        $this->collectionFactory = $quoteitemFactory;
        $this->etmail = $etmail;
        $this->quoteFactory = $quoteFactory;
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        $quoteid = $_REQUEST['quoteid'];
        $quote_id = $quoteid;
        $email = $this->quoteFactory->create()
            ->getCollection()->addFieldToSelect('customer_email')
            ->addFieldToFilter('quote_id', $quoteid)
            ->getFirstItem()->getData();
        $cust_email = $email['customer_email'];
        $data = $this->getRequest()->getParams();
        try {
            $model = $this->collectionFactory->create();

            foreach ($data as $index => $value) {
                if ($index == 'key') {
                    continue;
                }
                if (!$this->id) {
                    $this->id = $value;
                } else {
                    $model->load($this->id);
                    $model->setData('merchant_quoted_price', $data['price_' . $this->id]);
                    $this->id = null;
                }
                $saveData = $model->save();
            }
            $this->quoteFactory->create()
                ->load($quote_id)
                ->setData('merchant_quoted_price', 'yes')->save();
            if ($saveData) {

                $this->etmail->sendEmail($cust_email);

                $this->messageManager->addSuccess(__('Products Price Quoted Successfully !'));
            }
        } catch (\Exception $e) {
            $this->messageManager->addError(__($e->getMessage()));
        }
        $this->_redirect('*/*/index');
    }

}
