<?php

namespace Sprinix\RequestQuote\Controller\Index;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Data\Form\FormKey;
use Magento\Checkout\Model\Cart;
use Magento\Catalog\Model\Product;
use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Magento\Framework\Message\ManagerInterface;
use Magento\Catalog\Model\ProductFactory;
use Magento\Customer\Model\Session;
use Psr\Log\LoggerInterface;


/**
 * Class Addalltocart
 * @package Sprinix\RequestQuote\Controller\AddTags
 */
class Addalltocart extends Action
{
    /**
     * @var FormKey
     */
    protected $formKey;

    /**
     * @var \Magento\Catalog\Model\ProductFactory
     */
    protected $_productFactory;

    /**
     * @var Cart
     */
    protected $_cart;
    /**
     * @var \Magento\Framework\Message\ManagerInterface
     */
    protected $messageManager;

    /**
     * @var
     */
    protected $PostFactory;

    /**
     * @var
     */
    protected $qty;

    /**
     * @var
     */
    protected $productQty;

    /**
     * @var
     */
    protected $logger;

    /**
     * @var
     */
    protected $config_options;

    /**
     * @var
     */
    protected $info;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * Addalltocart constructor.
     * @param Context $context
     * @param QuoteItemFactory $PostFactory
     * @param FormKey $formKey
     * @param ManagerInterface $managerInterface
     * @param ProductFactory $productFactory
     * @param Cart $cart
     * @param Session $customerSession
     */
    public function __construct(
        Context $context,
        QuoteItemFactory $PostFactory,
        FormKey $formKey,
        ManagerInterface $managerInterface,
        ProductFactory $productFactory,
        Cart $cart,
        Session $customerSession,
        LoggerInterface $logger

    )
    {
        parent::__construct($context);
        $this->formKey = $formKey;
        $this->_productFactory = $productFactory;
        $this->_cart = $cart;
        $this->messageManager = $managerInterface;
        $this->postFactory = $PostFactory;
        $this->customerSession = $customerSession;
        $this->logger = $logger;
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        $this->_cart->truncate();
        $data = $this->getRequest()->getParam('data');
        $this->customerSession->setflag('request_quote_to_cart');
        if ($data) {
            foreach ($data as $key => $value) {
                $collecton = $this->postFactory->create();
                $item = $collecton->load($value);
                $custom_options_value = '';
                if (isset($item['super_attribute']) || !empty($item['super_attribute'])) {

                    $custom_options_value = unserialize($item['super_attribute']);
                }
                $this->addCartProduct($item['product_id'], $item['product_quantity'], $custom_options_value);
            }
            $this->_cart->save();
        }
        $this->messageManager->addSuccess('Products added  to cart succesfully.');
    }

    /**
     * @param $productID
     * @param $productQty
     * @param $config_options
     * @return Cart
     */
    public function addCartProduct($productID, $productQty, $config_options)
    {
        try{
            $product = $this->_productFactory->create()->load($productID);


            $info = new \Magento\Framework\DataObject(
                [
                    'form_key' => $this->formKey->getFormKey(),
                    'product_id' => $productID,
                    'qty' => $productQty,
                    'super_attribute' => $config_options,
                ]
            );
            return $this->_cart->addProduct($product, $info);
        }catch (\Exception $e) {
            $this->logger->critical($e->getMessage());
        }
    }
    public function unsetFlag(){
        $this->customerSession->unsflag();
    }
}
