<?php

namespace Sprinix\RequestQuote\Controller\index;

use Magento\Framework\Controller\Result\RedirectFactory;
use Magento\Customer\Model\Session;
use Magento\Framework\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Magento\Framework\Message\ManagerInterface;

/**
 * Class Customerview
 * @package Sprinix\RequestQuote\Controller\index
 */
class Customerview extends \Magento\Framework\App\Action\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $_pageFactory;

    /**
     * @var Session
     */
    protected $customerSession;

    /**
     * @var RedirectFactory
     */
    protected $resultRedirect;

    /**
     * @var
     */
    protected $messageManager;

    /**
     * Customerview constructor.
     * @param RedirectFactory $resultRedirect
     * @param Session $customerSession
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $pageFactory
     */
    public function __construct(
        RedirectFactory $resultRedirect,
        Session $customerSession,
        Context $context,
        PageFactory $pageFactory,
        ManagerInterface $messageManager)
    {
        $this->_pageFactory = $pageFactory;
        $this->customerSession = $customerSession;
        $this->resultRedirect = $resultRedirect;
        $this->messageManager = $messageManager;
        return parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\Result\Redirect|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        if (!$this->customerSession->isLoggedIn()) {
            $this->messageManager->addErrorMessage("you must be logged in to view your quote");
            return $this->resultRedirect->create()
                ->setPath('customer/account/login');
        } else {
            $resultPage = $this->_pageFactory->create();
            $resultPage->getConfig()->getTitle()->prepend((__('Here is your request quote')));
            return $resultPage;
        }
    }
}