<?php

namespace Sprinix\RequestQuote\Controller\Index;

use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Message\ManagerInterface;
use Magento\Customer\Model\Session;
use Sprinix\RequestQuote\Model\QuoteFactory;

/**
 * Class Delete
 * @package Request\RequestQuote\Controller\AddTags
 */
class Delete extends \Magento\Framework\App\Action\Action
{


    /**
     * @var \Magento\Customer\Model\Session
     */
    public $customerSession;
    /**
     * @var
     */
    protected $_commentFactory;
    /**
     * @var \Magento\Framework\Message\ManagerInterface
     */
    protected $messageManager;

    /**
     * @var QuoteItemFactory
     */
    protected $quoteitemFactory;

    /**
     * @var
     */
    protected $quoteFactory;


    public function __construct(
        Context $context,
        ManagerInterface $messageManager,
        Session $customerSession,
        QuoteItemFactory $quoteitemFactory,
        QuoteFactory $quoteFactory)
    {
        $this->quoteitemFactory = $quoteitemFactory;
        $this->messageManager = $messageManager;
        $this->customerSession = $customerSession;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        try {
            $flag = $this->customerSession->getSubmittedQuoteView();
            $data = $this->getRequest()->getParams();
            $id = $data['pid'];
            $qid = $data['qid'];
            $model = $this->quoteitemFactory->create();
            if ($flag == 'true') {
                $items = $model->getCollection()
                    ->addFieldToFilter('quote_id', $qid);
                if ($items->getSize() == 1) {
                    $this->quoteFactory->create()
                        ->load($qid)
                        ->delete();
                }
            }
            $model->load($id);
            $quantityChange = $model->getData('product_quantity');
            $model->delete();
            $this->messageManager->addSuccessMessage(__("Product deleted successfully."));
            $quantity = $this->customerSession->getrequestQuoteQuantity();
            if ($flag == 'false') {
                $quantity = $quantity - $quantityChange;
                if ($quantity < 0) {
                    $quantity = 0;
                }
            }
            $this->customerSession->setrequestQuoteQuantity($quantity);
        } catch (\Exception $e) {
        }
    }
}

?>