<?php

namespace Sprinix\RequestQuote\Controller\Index;

use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Message\ManagerInterface;
use Magento\Customer\Model\Session;
use Sprinix\RequestQuote\Model\QuoteFactory;

/**
 * Class Delete
 * @package Request\RequestQuote\Controller\AddTags
 */
class DeleteQuote extends \Magento\Framework\App\Action\Action
{


    /**
     * @var \Magento\Customer\Model\Session
     */
    public $customerSession;
    /**
     * @var
     */
    protected $_commentFactory;
    /**
     * @var \Magento\Framework\Message\ManagerInterface
     */
    protected $messageManager;
    /**
     * @var QuoteItemFactory
     */
    protected $quoteitemFactory;

    /**
     * @var
     */
    protected $quoteFactory;


    public function __construct(
        Context $context,
        ManagerInterface $messageManager,
        Session $customerSession,
        QuoteItemFactory $quoteitemFactory,
        QuoteFactory $quoteFactory
    )
    {
        $this->quoteitemFactory = $quoteitemFactory;
        $this->messageManager = $messageManager;
        $this->customerSession = $customerSession;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        try {
            $quantity = 0;
            $itemID = array();
            $quote_id = $this->getRequest()->getParam('qid');
            $items = $this->quoteitemFactory->create()
                ->getCollection()
                ->addFieldToSelect('id')
                ->addFieldToFilter('quote_id', $quote_id)
                ->getData();
            foreach ($items as $key => $values) {
                array_push($itemID, $values['id']);
            }
            foreach ($itemID as $key => $values) {
                $this->quoteitemFactory->create()
                    ->load($values)
                    ->delete();
            }
            $model = $this->quoteFactory->create()
                ->load($quote_id);
            $model->delete();
            $this->customerSession->setrequestQuoteQuantity($quantity);
            $this->messageManager->addSuccessMessage(__("Quote has been deleted  successfully"));
        } catch (\Exception $e) {
        }

    }


}

?>