<?php

namespace Sprinix\RequestQuote\Controller\Index;

use Magento\Framework\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\App\Action\Action;

/**
 * Class quotedetails
 * @package Sprinix\RequestQuote\Controller\AddTags
 */
class Quotedetails extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * quotedetails constructor.
     * @param Context $context
     * @param PageFactory $resultPageFactory
     * @param QuoteFactory $extensionFactory
     */

    /**
     * quotedetails constructor.
     * @param Context $context
     * @param PageFactory $resultPageFactory
     * @param QuoteFactory $extensionFactory
     */
    public function __construct(
        Context $context,
        PageFactory $resultPageFactory,
        QuoteFactory $quoteFactory

    )

    {
        $this->resultPageFactory = $resultPageFactory;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface
     * @throws \Exception
     */
    public function execute()
    {
        try {

            $data = $this->getRequest()->getParams('data');
            if ($data) {
                $model = $this->quoteFactory->create();
                $model->setData($data)->save();
                $this->messageManager->addSuccessMessage(__("Details has been added successfully"));
            }
            $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
            $resultRedirect->setUrl($this->_redirect->getRefererUrl());
            return $resultRedirect;
        }catch (\Exception $e){
        }
    }
}
