<?php

namespace Sprinix\RequestQuote\Controller\Index;

use Magento\Framework\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Framework\App\Action\Action;
use Magento\Catalog\Helper\Image;
use Magento\Customer\Model\Session;
use Magento\Catalog\Model\ProductFactory;
use Magento\Framework\Stdlib\DateTime\DateTime;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\Controller\Result\RedirectFactory;


/**
 * Class Save
 * @package Sprinix\RequestQuote\Controller\AddTags
 */
class Save extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var QuoteItemFactory
     */
    protected $quoteitemFactory;

    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * @var
     */
    protected $_productRepository;

    /**
     * @var Image
     */
    protected $imageHelper;

    /**
     * @var \Magento\Framework\Stdlib\DateTime\DateTime
     */
    protected $date;

    /**
     * @var
     */
    protected $message;

    /**
     * @var RedirectFactory
     */
    protected $resultRedirect;


    /**
     * Save constructor.
     * @param Context $context
     * @param PageFactory $resultPageFactory
     * @param QuoteItemFactory $quoteitemFactory
     * @param QuoteFactory $quoteFactory
     * @param Image $imageHelper
     * @param Session $CustomerSession
     * @param ProductFactory $productRepository
     * @param DateTime $date
     * @param ManagerInterface $message
     */
    public function __construct(
        Context $context,
        PageFactory $resultPageFactory,
        QuoteItemFactory $quoteitemFactory,
        QuoteFactory $quoteFactory,
        Image $imageHelper,
        Session $CustomerSession,
        ProductFactory $productRepository,
        DateTime $date,
        ManagerInterface $message,
        RedirectFactory $resultRedirect

    )

    {
        $this->resultPageFactory = $resultPageFactory;
        $this->quoteitemFactory = $quoteitemFactory;
        $this->quoteFactory = $quoteFactory;
        $this->customerSession = $CustomerSession;
        $this->_productRepository = $productRepository;
        $this->imageHelper = $imageHelper;
        $this->date = $date;
        $this->messageManager = $message;
        $this->resultRedirect = $resultRedirect;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        try {

            if ($this->customerSession->isLoggedIn())
            {
                $models = $this->quoteFactory->create();
                $cust_id = $this->customerSession->getCustomer()->getId();
                $customer_id = $this->customerSession->getCustomer()->getId();
                $customer_name = $this->customerSession->getCustomer()->getName();
                $customer_email = $this->customerSession->getCustomer()->getEmail();
                $date = $this->date->gmtDate();
                $quote = $models->getCollection()
                    ->addFieldToFilter('customer_id', ['eq' => $cust_id])
                    ->addFieldToFilter('customer_action_status', ['eq' => 'preparing']);

                if ($quote->getSize()) {
                    $details = $quote->getFirstItem();
                    $details = $details->getData();
                }
                if (empty($details) || ($details['customer_id'] != $cust_id && $details['customer_action_status'] != 'preparing')) {
                    $data = array(
                        'customer_id' => $customer_id,
                        'customer_name' => $customer_name,
                        'customer_email' => $customer_email,
                        'created_at' => $date
                    );
                    $models = $this->quoteFactory->create();

                    $models->setData($data)->save();

                    $current_quote = $quote->getFirstItem()->getData();
                    $current_quote = $current_quote['quote_id'];
                    $this->customerSession->setcurrentQuote($current_quote);
                    $models = $this->quoteFactory->create();
                    $quote = $models->getCollection()
                        ->addFieldToFilter('customer_id', ['eq' => $cust_id])
                        ->addFieldToFilter('customer_action_status', ['eq' => 'preparing']);
                    $current_quote = $quote->getFirstItem()->getData();
                    $current_quote = $current_quote['quote_id'];
                    $this->customerSession->setcurrentQuote($current_quote);

                } else {
                    $current_quote = $quote->getFirstItem()->getData();
                    $current_quote = $current_quote['quote_id'];
                    $this->customerSession->setcurrentQuote($current_quote);
                    $models = $this->quoteFactory->create();
                    $quote = $models->getCollection()
                        ->addFieldToFilter('customer_id', ['eq' => $cust_id])
                        ->addFieldToFilter('customer_action_status', ['eq' => 'preparing']);
                    $current_quote = $quote->getFirstItem()->getData();
                    $current_quote = $current_quote['quote_id'];
                    $this->customerSession->setcurrentQuote($current_quote);
                }

// code for adding items to the quoteitems table


                $formdata = $this->getRequest()->getParams();
                $sessionQuote = $this->customerSession->getcurrentQuote();
                $quote = $sessionQuote;

// data related to product

                $id = $formdata['product'];
                $items = $this->_productRepository->create()
                    ->load($id);
                $product_name = $items->getData('name');
                $product_price = $items->getData('price');
                $product_sku = $items->getData('sku');
                $product_url = $items->getProductUrl();
                $product_type = $items->getTypeId();
                $product_image_url = $this->imageHelper->init($items, 'product_thumbnail_image')->constrainOnly(true)
                    ->keepAspectRatio(true)
                    ->keepTransparency(true)
                    ->keepFrame(false)
                    ->resize(150, 150)->getUrl();

//data related to super attribute
                $product_id = $formdata['product'];
                $product_quantity = $formdata['qty'];
                $selected_configurable_option = $formdata['selected_configurable_option'];
                $related_product = $formdata['related_product'];
                $item = $formdata['item'];

// inserting all data into array
                if ($product_type == 'simple') {
                    $superdata = array
                    (
                        'product_id' => $product_id,
                        'product_name' => $product_name,
                        'product_url' => $product_url,
                        'product_price' => $product_price,
                        'product_image_url' => $product_image_url,
                        'customer_id' => $customer_id,
                        'customer_name' => $customer_name,
                        'customer_email' => $customer_email,
                        'product_quantity' => $product_quantity,
                        'product_sku' => $product_sku,
                        'selected_configurable_option' => $selected_configurable_option,
                        'related_product' => $related_product,
                        'item' => $item,
                        'quote_id' => $quote
                    );
                } else {
                    $superattr = $formdata['super_attribute'];
                    $super_attribute = serialize($superattr);
                    $superdata = array
                    (
                        'product_id' => $product_id,
                        'product_name' => $product_name,
                        'product_url' => $product_url,
                        'product_price' => $product_price,
                        'product_image_url' => $product_image_url,
                        'customer_id' => $customer_id,
                        'customer_name' => $customer_name,
                        'customer_email' => $customer_email,
                        'product_quantity' => $product_quantity,
                        'super_attribute' => $super_attribute,
                        'product_sku' => $product_sku,
                        'selected_configurable_option' => $selected_configurable_option,
                        'related_product' => $related_product,
                        'item' => $item,
                        'quote_id' => $quote
                    );
                }
                $model = $this->quoteitemFactory->create();
                $model->setData($superdata)->save();
                $this->productCount(); // quantity calculations for sections update
                $this->messageManager->addSuccessMessage(__("Product has been added to your quote successfully."));
            } else {
                $this->reDirect();
            }
        }catch (\Exception $e){
        }
    }


    /**
     *calculating the reamining quote quantity and then updating it in session
     */
    public function productCount()
    {
        $quantity = 0;
        $quoteId = $this->customerSession->getcurrentQuote();
        $count = $this->quoteitemFactory->create()
            ->getCollection()
            ->addFieldToFilter('quote_id', $quoteId)
            ->getData();
        foreach ($count as $item) {
            $quantity = $quantity + ($item['product_quantity']);
        }
        if ($quantity < 0 || empty($quantity)) {
            $quantity = 0;
        }
        $this->customerSession->setrequestQuoteQuantity($quantity);
        $this->customerSession->getrequestQuoteQuantity();
    }

    /**
     * @return \Magento\Framework\Controller\Result\Redirect
     */
    public function reDirect(){
        $this->messageManager->addErrorMessage("you must be logged in to add items in your quote");
        return $this->resultRedirect->create()
            ->setPath('customer/account/login');
    }

}

