<?php

namespace Sprinix\RequestQuote\Controller\index;

use Magento\Framework\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Customer\Model\Session;

/**
 * Class Submittedquotes
 * @package Sprinix\RequestQuote\Controller\index
 */
class Submittedquotes extends \Magento\Framework\App\Action\Action
{

    /**
     * @var
     */
    public $customerSession;
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $_pageFactory;
    /**
     * @var
     */
    protected $quoteitemFactory;
    /**
     * @var
     */
    protected $quoteFactory;

    /**
     * Submittedquotes constructor.
     * @param Context $context
     * @param PageFactory $pageFactory
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        QuoteItemFactory $quoteitemFactory,
        Session $customerSession,
        QuoteFactory $quoteFactory)

    {
        $this->_pageFactory = $pageFactory;
        $this->quoteitemFactory = $quoteitemFactory;
        $this->quoteFactory = $quoteFactory;
        $this->customerSession = $customerSession;
        return parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        $resultPage = $this->_pageFactory->create();
        $resultPage->getConfig()->getTitle()->prepend((__('Your  request quote history')));
        return $resultPage;
    }
}