<?php
/**
 * @package Request\RequestQuote
 */
namespace Sprinix\RequestQuote\CustomerData;

use Magento\Customer\CustomerData\SectionSourceInterface;
use Magento\Framework\View\Element\Template\Context;
use Magento\Customer\Model\Session;

/**
 * Class QuoteQuantitySection
 * @package Request\RequestQuote\CustomerData
 */
class QuantitySection implements SectionSourceInterface
{
    /**
     * @var \Magento\Customer\Model\Session
     */
    public $customerSession;

    /**
     * QuantitySection constructor.
     * @param Context $context
     * @param Session $customerSession
     * @param array $data
     */
    public function __construct(Context $context,
                                Session $customerSession,
                                array $data = []
    )
    {
        $this->customerSession = $customerSession;
    }


    /**
     * @return array
     */
    public function getSectionData()
    {
        $quantity = $this->customerSession->getrequestQuoteQuantity();
        if (empty($quantity)) {
            $quantity = 0;
        }
        return ['customdata' => "($quantity)",];
    }
}