<?php

namespace Sprinix\RequestQuote\Observer;

use Magento\Framework\Event\ObserverInterface;
use Sprinix\RequestQuote\Model\ResourceModel\QuoteItem\CollectionFactory;
use Magento\Customer\Model\Session;

/**
 * Class Quoteprice
 * @package Sprinix\RequestQuote\Observer
 */
class Quoteprice implements ObserverInterface
{

    /**
     * @var CollectionFactory
     */
    protected $resourceModel;

    /**
     * @var
     */
    protected $resultPageFactory;

    /**
     * @var
     */
    protected $quoteitemFactory;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * Quoteprice constructor.
     * @param CollectionFactory $resourceModel
     * @param \Magento\Customer\Model\Session $customerSession
     */
    public function __construct(CollectionFactory $resourceModel,
                                Session $customerSession
    )
    {
        $this->resourceModel = $resourceModel;
        $this->customerSession = $customerSession;
    }

    /**
     * @param \Magento\Framework\Event\Observer $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $check = $this->customerSession->getData('flag');
        $item = $observer->getEvent()->getData('quote_item');
        $itemProId = $item->getProduct()->getId();
        $orignalPrice = $item->getProduct()->getPrice();
        if ($check == "request_quote_to_cart") {
            $collection = $this->resourceModel->create()->addFieldToSelect('merchant_quoted_price')->addFieldToFilter('product_id', $itemProId)->load()->getData();
            foreach ($collection as $key => $value) {
                $qprice = $value['merchant_quoted_price'];
                if ($qprice == 'Not yet') {
                    $qprice = $orignalPrice;
                } else {
                    $price = $qprice;
                    $item->setCustomPrice($price);
                    $item->setOriginalCustomPrice($price);
                    $item->getProduct()->setIsSuperMode(true);
                }
            }
        } else {
            $qprice = $orignalPrice;
            $price = $qprice;
            $item->setCustomPrice($price);
            $item->setOriginalCustomPrice($price);
            $item->getProduct()->setIsSuperMode(true);
        }
    }
}



