<?php

namespace Sprinix\RequestQuote\Observer;

use Magento\Framework\Event\ObserverInterface;
use Sprinix\RequestQuote\Model\QuoteItemFactory;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Customer\Model\Session;

/**
 * Class StatusChange
 * @package Sprinix\RequestQuote\Observer
 */
class SectionQuantity implements ObserverInterface
{

    /**
     * @var
     */
    protected $logger;


    /**
     * @var QuoteFactory
     */
    protected $quoteFactory;

    /**
     * @var
     */
    protected $quoteitemFactory;


    /**
     * @var QuoteFactory
     */
    protected $quotationFactory;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * StatusChange constructor.
     * @param QuoteFactory $quotationFactory
     * @param \Magento\Customer\Model\Session $CustomerSession
     */
    public function __construct(
        Session $CustomerSession,
        QuoteItemFactory $quoteitemFactory,
        QuoteFactory $quoteFactory
    )


    {
        $this->customerSession = $CustomerSession;
        $this->quoteitemFactory = $quoteitemFactory;
        $this->quoteFactory = $quoteFactory;
    }


    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @throws \Exception
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        try {
            $cust_id = $this->customerSession->getCustomer()->getId();
            $models = $this->quoteFactory->create();
            $data = $models->getCollection()
                ->addFieldToFilter('customer_id', $cust_id)
                ->addFieldToFilter('customer_action_status', 'preparing')
                ->getFirstItem()
                ->getData();
            $quoteId = $data['quote_id'];
            $quantity = 0;
            $count = $this->quoteitemFactory->create()
                ->getCollection()
                ->addFieldToFilter('quote_id', $quoteId)
                ->getData();
            foreach ($count as $item) {
                $quantity = $quantity + ($item['product_quantity']);
            }
            if ($quantity < 0 || empty($quantity)) {
                $quantity = 0;
            }
            $this->customerSession->setrequestQuoteQuantity($quantity);
            $this->customerSession->setcurrentQuote($quoteId);
        } catch (\Exception $e) {
            echo "No quotes found";
        }

    }

}