<?php

namespace Sprinix\RequestQuote\Observer;

use Magento\Framework\Event\ObserverInterface;
use Sprinix\RequestQuote\Model\QuoteFactory;
use Magento\Customer\Model\Session;

/**
 * Class StatusChange
 * @package Sprinix\RequestQuote\Observer
 */
class StatusChange implements ObserverInterface
{

    /**
     * @var
     */
    protected $logger;

    /**
     * @var QuoteFactory
     */
    protected $quotationFactory;

    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $customerSession;

    /**
     * StatusChange constructor.
     * @param QuoteFactory $quotationFactory
     * @param \Magento\Customer\Model\Session $CustomerSession
     */
    public function __construct(QuoteFactory $quotationFactory, Session $CustomerSession)
    {
        $this->quotationFactory = $quotationFactory;
        $this->customerSession = $CustomerSession;
    }


    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @throws \Exception
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $quote_id = $this->customerSession->getcurrentQuote();
        $model = $this->quotationFactory->create()->load($quote_id);
        $model->setData('status', 'order placed');
        $model->save();
    }
}
